/*********************************************************************
 Copyright (C) 2012-present by nodeable limited ("nodeable") -
 www.nodeable.io.com and other contributors as listed below.
 All Rights Reserved.

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction except as noted below, including without limitation
the rights to use,copy, modify, merge, publish, distribute,
and/or sublicense, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

 The Software and/or source code cannot be copied in whole and
 sold without meaningful modification for a profit.

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 Redistributions of source code must retain the above copyright
 notice, this list of conditions and the following disclaimer.

 Redistributions in binary form must reproduce the above copyright
 notice, this list of conditions and the following disclaimer in
 the documentation and/or other materials provided with
 the distribution.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*********************************************************************/
/*------------------------------------------------------------------------
    File        : arat_init_rtbapis.i
    Purpose     :

    Syntax      :

    Description :

    Author(s)   :
    Created     : Sat Jul 05 14:36:34 CEST 2014
    Notes       :
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */
DEFINE VARIABLE cError                    AS CHARACTER                               NO-UNDO.
DEFINE VARIABLE hPropertiesTT             AS HANDLE                                  NO-UNDO.
DEFINE VARIABLE oFileHelper               AS appSolutions.appSolute.Utils.FileHelper NO-UNDO.
DEFINE VARIABLE AutomationClass           AS CHARACTER                               NO-UNDO INITIAL "appSolutions.appSolute.RTB.RTBAutomationApi".
DEFINE VARIABLE DeploymentAutomationClass AS CHARACTER                               NO-UNDO INITIAL "appSolutions.appSolute.Deployment.RTBDeploymentApi".

/* ***************************  Main Block  *************************** */
oFileHelper = NEW appSolutions.appSolute.Utils.FileHelper().
IF oFileHelper:FileExists(REPLACE(DeploymentAutomationClass + ".cls", ".":U, "/":U)) OR
    oFileHelper:FileExists(REPLACE(DeploymentAutomationClass + ".r", ".":U, "/":U)) THEN
DO:
    oRTBAutomationApi = DYNAMIC-NEW DeploymentAutomationClass().
END.
ELSE
    oRTBAutomationApi = DYNAMIC-NEW AutomationClass().

oRTBAutomationApi:init().

IF glcSessionProperties = "":U AND
    SESSION:PARAMETER NE "":U THEN
    ASSIGN
        glcSessionProperties = SESSION:PARAMETER.

ASSIGN
    glcSessionProperties = REPLACE(glcSessionProperties, "~\":U, "~/":U)
    glcSessionProperties = REPLACE(glcSessionProperties, "'":U, '"':U).

IF glcSessionProperties NE "":U THEN
DO:

    hPropertiesTT = (NEW scm.custom.rtb.Utils.TempTableHelper()):ConvertJsonToTtHandle(glcSessionProperties).

    IF VALID-HANDLE(hPropertiesTT) AND hPropertiesTT:HAS-RECORDS THEN
    DO:
        ghBuf = hPropertiesTT:DEFAULT-BUFFER-HANDLE.
        ghBuf:FIND-FIRST("":U).
        IF ghBuf:AVAILABLE THEN
            oRTBAutomationApi:validateParamCount(ghBuf:NUM-FIELDS, giParamsExpected).
    END.
    ELSE
        UNDO, THROW NEW Progress.Lang.AppError("Configration data not loaded. Procesing cannot continue", 0).
END.

RUN readParams.

IF VALID-OBJECT(oRTBAutomationApi) THEN
DO:
    ASSIGN
        oRTBAutomationApi:DebugOn         = glDebug
        oRTBAutomationApi:RtbUseAppServer = glUseAppServer.

    IF oRTBAutomationApi:RtbUseAppServer AND
        gcAppServerConnectString NE "":U THEN
        oRTBAutomationApi:connectAppServer(gcAppServerConnectString).
    ELSE
        oRTBAutomationApi:AppServerHandle = SESSION:HANDLE.

    /***DIAG***/
    MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
        "oRTBAutomationApi:DebugOn : " oRTBAutomationApi:DebugOn
        VIEW-AS ALERT-BOX INFO BUTTONS OK.

    IF oRTBAutomationApi:DebugOn THEN
    DO:
        ASSIGN
            cMessage = SUBSTITUTE("Session parameters: &1", glcSessionProperties).
        oRTBAutomationApi:displayMessage(cMessage, TRUE, TRUE).
    END.

    oRTBAutomationApi:startAPIs (
        INPUT  gcRTBInstallPath,
        INPUT  "":U,
        INPUT  gcUser,
        INPUT  gcPassword,
        INPUT  gcLogFile,
        OUTPUT hRTBApi,
        OUTPUT giSessionID).

    IF gcWorkspaceList BEGINS "File:":U THEN
    DO:
        gcWorkspaceList = oRTBAutomationApi:getWorkspaceListFromFile(gcWorkspaceList).
        ASSIGN
            cMessage = SUBSTITUTE("Processing workspace list: &1", gcWorkspaceList).
        oRTBAutomationApi:DisplayMessage(cMessage, TRUE, TRUE).

        IF cError NE "":U THEN
            UNDO, THROW NEW Progress.Lang.AppError(cError, 0).
    END.
    ELSE
        IF gcWorkspaceList = "*":U THEN
        DO:
            gcWorkspaceList = oRTBAutomationApi:RTBProxyHelper:custRtbGetWorkspaceList(gcWorkspaceList).
            ASSIGN
                cMessage = SUBSTITUTE("   Processing workspace list: &1", gcWorkspaceList).
            oRTBAutomationApi:DisplayMessage(cMessage, TRUE, TRUE).
        END.

    IF gcReportBaseDir NE "":U THEN
        ASSIGN
            oRTBAutomationApi:RtbReportBaseDir = gcReportBaseDir.
END.

DELETE OBJECT oFileHelper NO-ERROR.
DELETE OBJECT hPropertiesTT NO-ERROR.
