/**********************************************************************
* Copyright (C) 2012-2016 by nodeable limited, and                    *
* other contributors as listed below.  All Rights Reserved.           *
*                                                                     *
*  Software is distributed on an "AS IS", WITHOUT WARRANTY OF ANY     *
*   KIND, either express or implied.                                  *
*                                                                     *
*  Contributors:                                                      *
*  appSolutions, www.appsolutions.com                                 *
**********************************************************************/
/*------------------------------------------------------------------------
    File        : rtbcust_setRtbDeployStatus.p
    Purpose     : Set the status of a rtb_deploy record

    Syntax      : ppcSatus values are "Complete", "WIP"

    Author(s)   : Thomas Hansen
    Created     : Mon Mar 28 15:26:20 CEST 2016
    Notes       :
  ----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

DEFINE INPUT  PARAMETER pcWorkspace AS CHARACTER  NO-UNDO.
DEFINE INPUT  PARAMETER pcSiteCode  AS CHARACTER  NO-UNDO.
DEFINE INPUT  PARAMETER piSequence  AS INTEGER    NO-UNDO.
DEFINE INPUT  PARAMETER pcStatus    AS CHARACTER  NO-UNDO.
DEFINE OUTPUT PARAMETER pcError     AS CHARACTER  NO-UNDO.

{rtb/i/rtb_s_deploy.i}
{rtb/i/rtb_s_sess.i}

DEFINE VARIABLE iSessID AS INTEGER NO-UNDO.

iSessID = DYNAMIC-FUNCTION('fnRtbGetSessionProperty':U,'sid':U).

pcError = DYNAMIC-FUNCTION('fnRtbSetDeploymentStatus':U,
    INPUT  iSessID,
    INPUT  pcWorkspace,
    INPUT  pcSiteCode,
    INPUT  piSequence,
    INPUT  pcStatus).

RETURN.

FINALLY:
    fnRtbEndSuperProc(SESSION, MhDeploySuper, FALSE).
END FINALLY.
